property useframes, frameA, frameB, markA, markB, singleframe

on beginSprite me
  set singleframe to 0
  if useframes = #useframes then
    if frameB <= frameA then
      set singleframe to 1
    end if
  else
    set frameA to marker(markA)
    set frameB to marker(markB)
    if frameB <= frameA then
      set singleframe to 1
    end if
  end if
end

on prepareFrame me
  cursor([17, 18])
  if singleframe then
    if not frameReady(frameA) then
      go(marker(0))
    else
      cursor(-1)
      go(marker(1))
    end if
  else
    if not frameReady(frameA, frameB) then
      go(marker(0))
    else
      cursor(-1)
      go(marker(1))
    end if
  end if
end

on getPropertyDescriptionList
  set p_list to [#useframes: [#comment: "Syntax:", #format: #symbol, #range: [#useframes, #UseMarkers], #default: #useframes], #frameA: [#comment: "Begin Frame:", #format: #integer, #default: 1], #frameB: [#comment: "End Frame:", #format: #integer, #default: 1], #markA: [#comment: "Begin Marker:", #format: #marker, #default: 1], #markB: [#comment: "End Marker:", #format: #marker, #default: 1]]
  return p_list
end

on getBehaviorDescription
  return "Holds on the current frame using Go the Frame, until media in the specified frame range is loaded.  If End Frame is less than or equal to Begin Frame, only checks Begin Frame.  If desired, marker names can be used.  If the End Marker occurs before the Begin Marker, only the frame marked with Begin Marker is checked." & RETURN & "PARAMETERS:" & RETURN & "•Syntax - Deterimines whether frame range is specified with frame numbers or marker labels." & RETURN & "• Begin Frame - First frame to check if ready." & RETURN & "• End Frame - Last Frame to check if ready." & RETURN & "• Begin Marker - Marker label of first frame to check." & RETURN & "• End Marker - Marker label of last frame to check."
end
