property EventToSend, Addressee, whichevent

on mouseUp me
  if whichevent = #mouseUp then
    trigger(me)
  end if
end

on mouseDown me
  if whichevent = #mouseDown then
    trigger(me)
  end if
end

on prepareFrame me
  if whichevent = #prepareFrame then
    trigger(me)
  end if
end

on enterFrame me
  if whichevent = #enterFrame then
    trigger(me)
  end if
end

on exitFrame me
  if whichevent = #exitFrame then
    trigger(me)
  end if
end

on trigger me
  sendSprite(the Addressee of me, the EventToSend of me)
end

on getPropertyDescriptionList
  set p_list to [#EventToSend: [#comment: "Message:", #format: #symbol, #default: #generic_event], #Addressee: [#comment: "Target Sprite:", #format: #integer, #default: 1], #whichevent: [#comment: "Triggering Event:", #format: #symbol, #range: [#mouseUp, #mouseDown, #prepareFrame, #enterFrame, #exitFrame], #default: #mouseUp]]
  return p_list
end

on getBehaviorDescription
  return "Send a Message to the designated Sprite when the specified Event occurs.  At its destination the message will be interpreted as a sprite event and any actions defined for that event will be invoked." & RETURN & "PARAMETERS:" & RETURN & "• Message - name of event to invoke at target sprite." & RETURN & "• Target Sprite - number of sprite channel to which message should be sent." & RETURN & "• Triggering Event - event that should cause message to be sent." & RETURN & "NOTES:" & RETURN & "If the target sprite does not handle the message it will propagate to the cast member script, the current frame script, and then the movie, in search of a handler for that event."
end
