property name, setting, MemberZero, MemberOne, GroupName, MemberTwo

on setstate me, state, Addressee
  if voidp(Addressee) then
    do_SetState(me, state)
  else
    case Addressee of
      #all:
        do_SetState(me, state)
      (the name of me):
        do_SetState(me, state)
      (the GroupName of me):
        do_SetState(me, state)
    end case
  end if
end

on SwitchStates me, Addressee
  if voidp(Addressee) then
    do_SwitchStates(me)
  else
    case Addressee of
      #all:
        do_SwitchStates(me)
      (the name of me):
        do_SwitchStates(me)
      (the GroupName of me):
        do_SwitchStates(me)
    end case
  end if
end

on do_SetState me, state
  set the setting of me to state
  if state = 1 then
    set the member of sprite the spriteNum of me to the MemberOne of me
  else
    set the member of sprite the spriteNum of me to the MemberZero of me
  end if
end

on do_SwitchStates me
  if the setting of me = 0 then
    set the setting of me to 1
    set the member of sprite the spriteNum of me to the MemberOne of me
  else
    if the setting of me = 1 then
      set the setting of me to 0
      set the member of sprite the spriteNum of me to the MemberZero of me
    end if
  end if
  return the setting of me
end

on beginSprite me
  set the MemberOne of me to the member of sprite the spriteNum of me
  set the MemberZero of me to member the MemberNumTwo of me of castLib the castLibNum of the MemberOne of me
end

on getPropertyDescriptionList
  set p_list to [#name: [#comment: "Item Name:", #format: #symbol, #default: #twostate1], #MemberNumTwo: [#comment: "Alternate Image:", #format: #integer, #default: 1], #setting: [#comment: "Initially Toggled:", #format: #boolean, #default: 0], #GroupName: [#comment: "Group Name:", #format: #symbol, #default: #group1]]
  return p_list
end

on getBehaviorDescription
  return "Prepares a sprite to display a second bitmap castmember to represent an Alternate state.  State changes are requested by sending the Switch message.  Supports the creation of toggle buttons that can be used together in mutually exclusive multi-item Radio Groups." & RETURN & "PARAMETERS:" & RETURN & "• Item Name - ( optional ) name of this control." & RETURN & "• Alternate Image - number of castmember whose image will replace normal image.  Must be stored in same cast library as Normal castmember." & RETURN & "• Initially Toggled - check this box if sprite's current castmember represents the Alternate rather than the Normal image." & RETURN & "• Group Name - ( optional ) name of radio group to which this sprite will belong." & RETURN & "MESSAGES:" & RETURN & "• SwitchStates [ID] - show whichever image is not currently visible." & RETURN & "                    - returns the state (0,1) that the sprite becomes." & RETURN & "• SetState {0 or 1}, [ID] - Set to Normal Picture or Alternate Picture.  If the ID is omitted any sprite receiving the message will SetState."
end
