global gNetImageSprite, gNetMember, gTextInfoSprite, gNetImagePath, gLocalImagePath, gWaitingForNetImport

on enterFrame
  set gNetImageSprite to 5
  set gTextInfoSprite to 12
  set gNetImagePath to "./Stream-Images/"
  set gLocalImagePath to "Stream-Images/"
  loadSeasonalMedia()
  setUpTextInfo()
end

on loadSeasonalMedia
  global version
  set monthIndex to [3: "1-3", 5: "4-5", 7: "6-7", 9: "8-9", 10: "10-10", 12: "11-12"]
  sort(monthIndex)
  set oldDelim to the itemDelimiter
  set the itemDelimiter to "/"
  set theMonth to integer(item 1 of the short date)
  set baseFileName to getAt(monthIndex, findPosNear(monthIndex, value(theMonth)))
  if the number of member baseFileName = -1 then
    set gNetMember to new(#bitmap, castLib 1)
    if version contains "net" then
      set filePath to gNetImagePath & baseFileName & ".pct"
      importFileInto(gNetMember, filePath)
      set gWaitingForNetImport to 1
    else
      set filePath to the pathName & localPath(gLocalImagePath) & baseFileName & ".pct"
      importFileInto(gNetMember, filePath)
      set the member of sprite gNetImageSprite to gNetMember
    end if
  else
    set the member of sprite gNetImageSprite to member baseFileName
  end if
  sendSprite(gNetImageSprite, #visOn)
  set textCastLib to the castLibNum of sprite gTextInfoSprite
  set the member of sprite gTextInfoSprite to member (baseFileName & ".txt") of castLib textCastLib
  set the itemDelimiter to oldDelim
end

on setUpTextInfo
  set oldDelim to the itemDelimiter
  set the itemDelimiter to ","
  put item 2 of the long date into field "currentDate"
  set the itemDelimiter to oldDelim
end

on exitFrame
  sendAllSprites(#fixState)
end
